<?php

namespace Magalu\Resources;

class Variations extends \Magalu\Marketplace {

	private $sku;

	public function __construct($data) {
		$this->conf = $data->conf;
	}

	/**
	 * Definir SKU padrão
	 * @param type $sku
	 * @return type
	 */
	public function setSku($sku) {
		$this->sku = $sku;
	}

	public function get() {
		return $this->apiCall('GET', '/variations/'.rawurlencode($this->sku));
	}

	/**
	 * Adicionar variação a um produto
	 * @param type $variation
	 * @return type
	 */
	public function insert($variation) {

		if (is_null($this->sku))
			return ['error'=>'Informe o SKU da variação do produto.'];

		if (!is_array($variation))
			return ['error'=>'Variação deve ser um array.'];

		return $this->apiCall('POST', '/products/'.rawurlencode($this->sku).'/variations', ['variation'=>$variation]);

	}

	public function update($sku, $variation) {

		if (!is_array($variation))
			return ['error'=>'Variação deve ser um array.'];

		return $this->apiCall('PUT', '/variations/'.$sku, ['variation'=>$variation]);

	}

	public function delete($sku) {
		return $this->apiCall('DELETE', '/variations/'.rawurlencode($sku));
	}

}
